Almis Web Engine > **[Home](../README.md)**

---

# **Purpose**

## Table of Contents

* **[Introduction](#introduction)**
* **[What is AWE?](#what-is-awe)**
* **[Technology stack](#technology-stack)**

## Introduction

We look forward to create a product which helps software companies in overcoming the problems they are usually faced to:

* Large development team implies **huge training costs** on new technologies and losing focus on business logic.
* **Need of migration** instead of rebuild old applications from scratch.
* Technology evolution is accelerating and we need **stable process of development**.

## What is AWE?

AWE is an engine which allows developers to define structures which are translated 
into web screens, **without knowing anything about web development** and getting isolated 
from web technology advances impact, but getting benefit of them.

AWE also provides some tools to easy the web development, as:

* Configure your **authentication** method.
* Make **queries** to SQL and NO-SQL databases.
* Send/receive messages over **JMS queues**.
* Launch **services** to interact with your business logic:
  * Direct **Java** method calls.
  * Connect to **microservice** architectures.
  * Simplified **REST** API calls.
* Automatic **email** composing made easy.
* Retrieve screen data as a **report**.
* **Multiple language** support.
* Customize your application with our color **themes**.
* Add our **pregenerated screens** ready to be used.

## Modules

There are some modules developed around AWE which offers some useful functionalities for AWE applications development and management.
Actual modules are:
* **Developer**: Development tools to ease AWE applications development. Here you can find some functionalities such as dynamic locale generation or CRUD window generation. 
* **Scheduler**: Process scheduler. Allows to run scheduled tasks when their requirements are fulfilled: launch on a certain date, when a file has changed or manually.
* **Tools**: Set of DevOps tools which can be integrated as application options. It contains a SQL query launcher or a file manager.
* **Rest**: Module which generates a REST API automatically for the AWE-generated application. It contains automatic documentation generated by Swagger.

## Technology stack

Check our latest technology stack on [Stackshare.io](https://stackshare.io/almis-informatica-financiera/aweframeworkk).

### Languages

* HTML5
* Javascript/ES6/ES7
* Java
* CSS
* Markdown

### Frameworks

* AngularJS & ES6
* Less
* Spring Framework
* Bootstrap

### Libraries

* Redux.js
* Socket.IO
* Highcharts
* Font Awesome

### Databases

* MongoDB
* Microsoft SQL Server
* MySQL
* MariaDB
* Oracle
* HSQLDB

### Application servers

* Apache Tomcat
* WildFly
* Oracle Weblogic
* IBM Websphere

### DevOps

* Build tools
  * Apache Maven
  * Node
  * Yarn
  * Webpack
  * Babel

* Version control & documentation
  * Git
  * GitLab
  * Markdown

* QA & Analytics
  * Gitlab CI
  * Docker
  * Kubernetes
  * ESLint
  * Sonarcloud
  * JUnit
  * Karma & Jasmine
  * Selenium